package twolists;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Collections;
import java.util.Vector;

import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListSelectionModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;

class MyCellRenderer extends DefaultListCellRenderer {

    /*
     * This is the only method defined by ListCellRenderer. We just reconfigure
     * the Jlabel each time we're called.
     */
    public Component getListCellRendererComponent(JList list, Object value, // value
									    // to
									    // display
	    int index, // cell index
	    boolean iss, // is the cell selected
	    boolean chf) // the list and the cell have the focus
    {
	/*
	 * The DefaultListCellRenderer class will take care of the JLabels text
	 * property, it's foreground and background colors, and so on.
	 */
	Person temp = (Person) value;
	MyLabel lab = new MyLabel(temp.toString(), temp.color, list.getWidth() - 15);
	return lab;
    }
}

public class BasicGUI extends JFrame {
    int w = 500;

    int h = 500;

    JList<Person> lst1;

    JPanel panel;

    JList<Person> lst2;

    Vector<Person> man1;

    Vector<Person> man2;

    JButton btn1;

    JButton btn2;

    JButton btn3;

    JButton btn4;

    Vector<Person> temp;

    BasicGUI() {
	super();
	setVisible(true);
	setPreferredSize(new Dimension(h, w));
	Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
	setLocation((dim.width - w) / 2, (dim.height - h) / 2);
	dodaj();
	pack();
	setDefaultCloseOperation(EXIT_ON_CLOSE);
    }

    public void dodaj() {
	btn1 = new JButton(">");
	btn2 = new JButton("<");
	btn3 = new JButton(">>");
	btn4 = new JButton("<<");
	setLayout(new GridLayout(1, 3));
	man1 = new Vector<Person>();
	man1.add(new Person(1990, "Marko", Color.ORANGE));
	man1.add(new Person(2003, "Mika", Color.BLUE));
	man1.add(new Person(2000, "Pera", Color.RED));
	man1.add(new Person(1993, "Aljosa", Color.PINK));
	man2 = new Vector<Person>();
	man2.add(new Person(2003, "Andjela", Color.GREEN));
	man2.add(new Person(2596, "Mina", Color.GRAY));
	man2.add(new Person(28374, "Bojana", Color.YELLOW));
	man2.add(new Person(2884, "Sonja", Color.CYAN));
	lst2 = new JList<Person>(man2);
	lst1 = new JList<Person>(man1);
	lst2.setSelectionMode(DefaultListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
	lst1.setSelectionMode(DefaultListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

	lst1.setCellRenderer(new MyCellRenderer());
	lst2.setCellRenderer(new MyCellRenderer());

	add(lst1);
	panel = new JPanel();
	panel.setLayout(new GridLayout(5, 1));
	JButton sort1;
	sort1 = new JButton("sort");
	panel.add(btn1);
	panel.add(btn2);
	panel.add(sort1);
	panel.add(btn3);
	panel.add(btn4);
	add(panel);
	add(lst2);
	sort1.addActionListener(new ActionListener() {

	    @Override
	    public void actionPerformed(ActionEvent e) {
		Collections.sort(man1);
		lst1.repaint();
		Collections.sort(man2);
		lst2.repaint();
	    }
	});
	btn1.addActionListener(new ActionListener() {

	    @Override
	    public void actionPerformed(ActionEvent arg0) {
		int arr[];
		arr = lst1.getSelectedIndices();
		temp = new Vector<Person>();
		for (int i = 0; i < arr.length; i++)
		    temp.add(man1.get(arr[i]));
		for (int i = 0; i < arr.length; i++)
		    man2.add(man1.get(arr[i]));
		man1.removeAll(temp);
		if (man1.isEmpty()) {
		    btn1.setEnabled(false);
		    btn3.setEnabled(false);
		}
		lst1.setListData(man1);
		lst2.setListData(man2);
		btn2.setEnabled(true);
		btn4.setEnabled(true);
		lst2.repaint();
		lst1.repaint();
	    }
	});
	btn2.addActionListener(new ActionListener() {

	    @Override
	    public void actionPerformed(ActionEvent arg0) {
		btn1.setEnabled(true);
		int arr[];
		arr = lst2.getSelectedIndices();
		temp = new Vector<Person>();
		for (int i = 0; i < arr.length; i++)
		    temp.add(man2.get(arr[i]));
		for (int i = 0; i < arr.length; i++)
		    man1.add(man2.get(arr[i]));
		man2.removeAll(temp);
		if (man2.isEmpty()) {
		    btn2.setEnabled(false);
		    btn4.setEnabled(false);
		}
		lst1.setListData(man1);
		lst2.setListData(man2);
		btn3.setEnabled(true);
		lst2.repaint();
		lst1.repaint();
	    }
	});
	btn3.addActionListener(new ActionListener() {

	    @Override
	    public void actionPerformed(ActionEvent arg0) {
		man2.addAll(man1);
		btn4.setEnabled(true);
		btn2.setEnabled(true);
		man1.removeAllElements();
		lst2.setListData(man2);
		btn3.setEnabled(false);
		btn1.setEnabled(false);
		lst2.repaint();
		lst1.repaint();
	    }
	});
	btn4.addActionListener(new ActionListener() {

	    @Override
	    public void actionPerformed(ActionEvent arg0) {
		man1.addAll(man2);
		btn3.setEnabled(true);
		btn1.setEnabled(true);
		man2.removeAllElements();
		lst1.setListData(man1);
		lst2.setListData(man2);
		btn4.setEnabled(false);
		btn2.setEnabled(false);
		lst2.repaint();
		lst1.repaint();
	    }
	});
    }

    public static void main(String[] args) {
	BasicGUI gui = new BasicGUI();
    }

}
